"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.trackDocLoggerPackage = void 0;
var clonedeep_1 = __importDefault(require("clonedeep"));
var fast_deep_equal_1 = __importDefault(require("fast-deep-equal"));
var Package_1 = require("../Package");
var options = {
    docsToTrackFn: function (docs) { return undefined; }
};
var generations = [];
var previousTrackedDocs;
exports.trackDocLoggerPackage = new Package_1.Package('trackDocLogger')
    .factory('trackDocLoggerOptions', function () {
    return options;
})
    .eventHandler('processorEnd', function () {
    return function (event, processor, docs) {
        var trackedDocs = options.docsToTrackFn(docs);
        if (trackedDocs) {
            if (!fast_deep_equal_1.default(trackedDocs, previousTrackedDocs)) {
                trackedDocs = clonedeep_1.default(trackedDocs);
                generations.push({ processor: processor.name, docs: trackedDocs });
                previousTrackedDocs = trackedDocs;
            }
        }
    };
})
    .eventHandler('generationEnd', function (log) {
    return function () {
        log.info('trackDocLogger settings:', options);
        log.info('trackDocLogger tracked changes:', generations);
    };
});
//# sourceMappingURL=trackDocLogger.js.map